WireGuard 一键安装脚本

技术 秋水逸冰 107134 次围观 144 次吐槽

本脚本适用环境

系统支持:CentOS 7+,Debian 8+,Raspbian 10,Ubuntu 16+,Fedora 29+
内存要求:≥256M
日期  :2020 年 4 月 2 日

关于本脚本

1. 支持两种安装方式:从代码编译安装,从 repository 直接安装;
2. 脚本会创建默认的 wg0 设备,以及 wg0 的客户端配置,并生成客户端配置对应的二维码 png 图片;
3. 脚本会修改本机防火墙设置,如果未启用防火墙,则会出现警告提示,需要手动去设置;
4. 脚本会从 1024 到 20480 随机生成监听端口;
5. 脚本支持新增,删除,列出客户端功能;
6. 脚本支持查看已安装的 WireGuard 的版本号;
7. 脚本支持从代码编译安装的方式升级 WireGuard 到当前最新版本;

客户端下载

Windows, macOS, Android, iOS 客户端
https://www.wireguard.com/install/

脚本使用方法

使用 root 用户登录系统,运行以下命令下载脚本,赋予执行权限:

wget --no-check-certificate -O /opt/wireguard.sh https://raw.githubusercontent.com/teddysun/across/master/wireguard.sh
chmod 755 /opt/wireguard.sh

写在前面

WireGuard 的安装和使用条件是比较苛刻的。因此我不建议在生产系统里安装和使用 WireGuard,除非你知道自己在做什么。
它依赖于内核,也就是 kernel,在不同的系统中,内核,内核源码包,内核头文件必须存在且这三者版本要一致。
RedHat,CentOS,Fedora,Oracle Linux,Amazon Linux 等 rpm 系的名字是 kernel,kernel-devel,kernel-headers。
Debian,Ubuntu 等 deb 系的名字是 kernel,linux-headers。
如果这三者任一条件不满足的话,则不管是从代码编译安装还是从 repository 直接安装,也只是安装了 wireguard-tools 而已。
而 WireGuard 真正工作的部分,是 wireguard-dkms,也就是动态内核模块支持(DKMS),是它将 WireGuard 编译到系统内核中。
因此,在某些 VPS 商家,是需要你先自主更换系统内核,并事先将这三者安装好,才有可能不会出现编译或安装失败。

我在测试的时候,就经历过各种内核的问题导致的安装失败。如果你也遇到了同样的问题,建议先更换内核。
就我个人的体验而言,在 CentOS 7 下更换为 elrepo 的内核是最容易的。这里有个脚本,可以更换到最新版内核,且自动开启 BBR 网络传输算法。
一键安装最新内核并开启 BBR 脚本
此脚本运行后,最后会提示你重启系统,此时可以输入 n,暂不重启。手动安装 kernel-headers,运行如下命令:

yum -y install kernel-ml-headers

然后再重启之。运行如下命令:

reboot

重启后进入系统,运行下面的从代码编译安装 WireGuard,基本上就不会出现安装失败的问题了。
注意:自主更换内核后,我建议使用从代码编译安装 WireGuard。

更新日志

2020 年 4 月 2 日:
Linux 内核 5.6 正式发布了,内置了 wireguard module。
本次更新添加了检测系统内核版本,如果大于等于 5.6 则不安装 wireguard module,仅安装 wireguard tools,然后再生成默认配置。
当系统内核小于 5.6 时,则依然安装 wireguard module 和 tools,并生成默认配置。

2020 年 1 月 6 日:
一个好消息是 WireGuard 即将要合并到内核 5.6 里面了。
于是作者在近期把 repo 改名了,从而导致脚本无法获取到正确的版本号。
并且还把原来的 repo 一分为二了,分别改为 wireguard-linux-compat 和 wireguard-tools。前者是内核模块,后者是命令行工具。
此次更新就是修复了以上问题。

2019 年 11 月 16 日:
1、修正客户端配置文件创建时的各参数顺序,与 Windows 客户端的显示顺序一致。
2、新增 Windows 客户端配置示例说明。

2019 年 10 月 27 日:
1、新增卸载函数,使用方法请参考下面的卸载方法
2、支持在 CentOS8 下从 repository 安装,或者从代码编译安装。

从代码编译安装 WireGuard

/opt/wireguard.sh -s

从 repository 直接安装 WireGuard

/opt/wireguard.sh -r

安装完成后,脚本提示如下

WireGuard VPN Server installation completed
WireGuard VPN default client file is below:
/etc/wireguard/wg0_client
WireGuard VPN default client QR Code is below:
/etc/wireguard/wg0_client.png
Download and scan this QR Code with your phone
Welcome to visit: https://teddysun.com/554.html
Enjoy it

卸载方法

/opt/wireguard.sh -n

其他使用选项

查看已安装 WireGuard 版本号

/opt/wireguard.sh -v

编译升级 WireGuard 到当前最新版本

/opt/wireguard.sh -u

新增 WireGuard 客户端配置

/opt/wireguard.sh -a

删除 WireGuard 客户端配置
注意:默认客户端 wg0 不允许删除

/opt/wireguard.sh -d

列出 WireGuard 客户端配置

/opt/wireguard.sh -l

高级用法

如果你在安装时,需要自定义自己想要的端口,那么可以 export 变量 VPN_SERVER_WG_PORT 的值,这样脚本就会读取这个变量值来定义监听端口,而不会自己随机生成。
比如你想自定义端口为 1234,那么具体做法就是,在执行从代码编译安装 WireGuard 或者从 repository 直接安装 WireGuard 之前,运行如下命令:

export VPN_SERVER_WG_PORT=1234

下面是一份脚本里用到的变量列表名(共计 11 个),以及它们具体代表什么含义的说明。
VPN_SERVER_PUB_IPV4,定义服务器公网 IPv4,如果你的服务器端存在多个可用公网 IPv4,指定此变量的值。
VPN_SERVER_PUB_IPV6,定义服务器公网 IPv6,如果你的服务器端存在多个可用公网 IPv6,指定此变量的值。
VPN_SERVER_PUB_NIC,定义服务器默认网卡名称,如果你的服务器有多个可用网卡,指定此变量的值。
VPN_SERVER_WG_NIC,定义 WireGuard 网卡名,默认为 wg0,这里一般不推荐指定此变量的值。
VPN_SERVER_WG_IPV4,定义 WireGuard 服务端的内网 IPv4,默认为 10.88.88.1,这里一般不推荐指定此变量的值。
VPN_SERVER_WG_IPV6,定义 WireGuard 服务端的内网 IPv6,默认为 fd88:88:88::1,这里一般不推荐指定此变量的值。
VPN_SERVER_WG_PORT,定义器 WireGuard 服务端的监听端口,默认为从 1024 到 20480 随机生成,如果你想自定义端口,指定此变量的值。
VPN_CLIENT_WG_IPV4,定义 WireGuard 默认客户端的内网 IPv4,默认为 10.88.88.2,这里一般不推荐指定此变量的值。
VPN_CLIENT_WG_IPV6,定义 WireGuard 默认客户端的内网 IPv6,默认为 fd88:88:88::2,这里一般不推荐指定此变量的值。
VPN_CLIENT_DNS_1,定义 WireGuard 默认客户端的 DNS,默认为 1.1.1.1,如果你想自定义为别的 DNS,指定此变量的值。
VPN_CLIENT_DNS_2,定义 WireGuard 默认客户端的 DNS,默认为 8.8.8.8,如果你想自定义为别的 DNS,指定此变量的值。

Windows 客户端配置

下载,安装,打开客户端软件,点击 Add Tunnel -> Add empty tunnel…

此时出现一个可以编辑的界面,将脚本生成的客户端配置 /etc/wireguard/wg0_client 里的内容复制出来,粘贴,保存。

点击 Activate,就可以 VPN 连接了。

参考链接

https://www.wireguard.com
https://github.com/WireGuard/WireGuard
https://git.zx2c4.com/WireGuard
https://golb.hplar.ch/2019/07/wireguard-windows.html

转载请注明:秋水逸冰 » WireGuard 一键安装脚本

发表我的评论
取消评论

请输入正确答案后提交评论 *

表情

Hi,您需要填写昵称和邮箱!

  • 昵称 (必填)
  • 邮箱 (必填)
  • 网址

网友最新评论 (144)

  1. 如果vps(centos7的GCP)上既没有安装firewalld也没有iptables的情况下,好像没法实现端口转发,导致能连接服务器,但没有网络,能ping通内网IP:10.88.88.2。
    dky19965个月前 (2020-05-21)回复
    • 所有的 VPN 都要依赖于端口转发才能连接外网。所以 firewalld 和 iptables 总得有一个才行。
      秋水逸冰5个月前 (2020-05-24)回复
  2. 安装出现 Execution command (systemctl stop [email protected]) failed, please check it and try agai n. 然后无法继续安装也无法卸载
    cnc6个月前 (2020-05-08)回复
  3. ShadowsoksR no working whatsapp
    Andy6个月前 (2020-04-30)回复
  4. 建议在创建wg0_client客户端配置的时候在[Interface]里加一行MTU = 1360。可以解决GCP搭的Wireguard无法访问谷歌自家网站的问题。另外提醒一下如果打算用GCP搭Wireguard,系统直接选Ubuntu 19.10就行,不用升级内核啥的。谷歌的18.04 LTS我试了内核有问题,Debian和Centos不清楚。
    tobwb6个月前 (2020-04-16)回复
    • 你好,首先感谢你的建议。 关于设置 MTU 值的问题,目前看起来只对 GCP 上访问 Google 自家网站有影响。如果这么设置后,会不会对其他非 GCP 的也会产生影响,还需要测试来证实。 如果你能提供充分的证据的话,欢迎你 pull request 到 GitHub!
      秋水逸冰6个月前 (2020-04-17)回复
  5. 用老大的脚本在vps跑了一下,最后安装成功,过程中觉得脚本有一点点可能要改一下。224行取kernel version时,我的已经5.6.3了,也是用老大的脚本升级了内核(cnetos7).805行:if [ ${rt} -eq 2 ]; 2是个笔误,应是0。不然用-r安装,脚本就跑不下去了。最后还是要谢谢老大脚本,方便了大家。谢谢
    自己玩7个月前 (2020-04-11)回复
    • 805行:if [ ${rt} -eq 2 ]; 2不是笔误。${rt} 是取自函数 _is_installed 的返回值。
      秋水逸冰6个月前 (2020-04-17)回复
      • 秋水大大我的内核是5.6.5.安装wg之前使用的你的bbr一件安装包,现在要安装Wireguard,无法进行,提示:WireGuard module does not exists, please check your kernel,VPS在azure
        flame6个月前 (2020-04-18)回复
        • 安装完新内核后一般需要重启才能使新内核生效。 使用命令uname -a查看内核版本。 出现这个错误是因为某种原因,没有检测到内核里的 wireguard 模块。 根据刚才的命令,你可以在此反馈一下你的系统版本是什么。
          秋水逸冰6个月前 (2020-04-21)回复
          • # sh /opt/wireguard.sh -v WireGuard module is exist, but WireGuard tools does not exists # sh/opt/wireguard.sh -s Check OS version WireGuard module does not exists, please check your kernel ----------------------- # rpm -qa | grep kernel kernel-ml-headers-5.6.6-1.el7.elrepo.x86_64 kernel-ml-5.6.6-1.el7.elrepo.x86_64 kernel-ml-devel-5.6.6-1.el7.elrepo.x86_64
            anonymous6个月前 (2020-04-23)回复
            • kernel-ml-5.6.x 内核是自带 wireguard 模块的。 我这边测试的时候也是安装的这个,不知道为什么你那边是显示没有的,在安装完新内核后,需要重启一下 VPS 的。
              秋水逸冰6个月前 (2020-04-25)回复
            • sorry,确实是bug导致的问题,我已经在 4 月 26 日修复了此问题。
              秋水逸冰6个月前 (2020-04-30)回复
  6. windows版本wiregurad,访问google直接提示网络已断开?之前一直用的好好的,有跟我一样的小伙伴?
    bcc22097个月前 (2020-04-06)回复
  7. WireGuard module does not exists, please check your kernel,不管用代码编译安装,还是repository,都显示这个,请问怎么处理呢?谢谢
    老孙7个月前 (2020-04-06)回复
    • 意思是说,你的系统里,内核版本已经大于等于 5.6 了,但是因为某种原因,内核里并没有集成 wireguard 的模块,所以才会有这个提示。 个人猜测这个内核应该是自行编译的之类的。
      秋水逸冰6个月前 (2020-04-17)回复
  8. 小白反馈: 在手动更新了5.6.2内核后脚本报错如下 [[email protected] ~]# /opt/wireguard.sh -s [Sun Apr 5 08:30:08 UTC 2020] Check OS version [Sun Apr 5 08:30:08 UTC 2020] WireGuard module does not exists, please check your kernel 在去掉脚本的内核版本判断后,脚本运行了起来,报错: [[email protected] ~]# /opt/wireguard.sh -s [Sun Apr 5 08:37:23 UTC 2020] Check OS version [Sun Apr 5 08:37:23 UTC 2020] Install dependencies for wireguard [Sun Apr 5 08:37:23 UTC 2020] yum -y install epel-release [Sun Apr 5 08:37:25 UTC 2020] yum -y install qrencode [Sun Apr 5 08:37:28 UTC 2020] yum -y install bc [Sun Apr 5 08:37:30 UTC 2020] yum -y install gcc [Sun Apr 5 08:37:42 UTC 2020] yum -y install make [Sun Apr 5 08:37:47 UTC 2020] yum -y install yum-utils [Sun Apr 5 08:37:50 UTC 2020] yum-config-manager --enable PowerTools [Sun Apr 5 08:37:51 UTC 2020] yum -y install libmnl-devel [Sun Apr 5 08:37:58 UTC 2020] yum -y install elfutils-libelf-devel [Sun Apr 5 08:38:01 UTC 2020] Install wireguard from source [Sun Apr 5 08:38:02 UTC 2020] wget --no-check-certificate -qO wireguard-linux-compat-1.0.20200401.tar.gz https://github.com/WireGuard/wireguard-linux-compat/archive/v1.0.20200401.tar.gz [Sun Apr 5 08:38:03 UTC 2020] tar zxf wireguard-linux-compat-1.0.20200401.tar.gz [Sun Apr 5 08:38:03 UTC 2020] cd wireguard-linux-compat-1.0.20200401/src [Sun Apr 5 08:38:03 UTC 2020] make In file included from : /opt/wireguard-linux-compat-1.0.20200401/src/compat/compat.h:47:2: error: #error "WireGuard has been merged into Linux >= 5.6 and therefore this compatibility module is no longer required." #error "WireGuard has been merged into Linux >= 5.6 and therefore this compatibility module is no longer required." ^~~~~ make[2]: *** [scripts/Makefile.build:268: /opt/wireguard-linux-compat-1.0.20200401/src/main.o] Error 1 make[1]: *** [Makefile:1683: /opt/wireguard-linux-compat-1.0.20200401/src] Error 2 make: *** [Makefile:25: module] Error 2 [Sun Apr 5 08:38:06 UTC 2020] Execution command (make) failed, please check it and try again. 内核部分信息: [[email protected] ~]# rpm -qa | grep kernel kernel-ml-devel-5.6.2-1.el8.elrepo.x86_64 kernel-ml-core-5.6.2-1.el8.elrepo.x86_64 kernel-ml-5.6.2-1.el8.elrepo.x86_64 kernel-ml-headers-5.6.2-1.el8.elrepo.x86_64 kernel-ml-modules-5.6.2-1.el8.elrepo.x86_64
    小白7个月前 (2020-04-05)回复
    • 抱歉。这一天我应该还在完善脚本,正好你用到了含有 bug 的那个阶段的脚本了。 请下载最新版的脚本使用即可。
      秋水逸冰6个月前 (2020-04-17)回复
  9. GCP的debian9 4.9内核好像是个假的4.9,wireguard有问题
    lisa19367个月前 (2020-03-22)回复
  10. 啊哈,来自翻墙留言的一枚萌新,谢谢你以前的一键脚本,虽然只用了不久没没折腾了
    青找7个月前 (2020-03-19)回复
  11. 你好,使用这个脚本安装完成后,IPv4连接正常,IPv6连接出现问题。 服务器为Linode, Tokyo2,客户端为Windows 10,天津联通IPv6。 日志: 2020-03-13 19:01:40.265: [TUN] [test] Bringing peers up 2020-03-13 19:01:40.266: [TUN] [test] Routine: receive incoming IPv6 - started 2020-03-13 19:01:40.266: [TUN] [test] Routine: receive incoming IPv4 - started 2020-03-13 19:01:40.266: [TUN] [test] UDP bind has been updated 2020-03-13 19:01:40.266: [TUN] [test] peer(bBF4…6PH4) - Starting... 2020-03-13 19:01:40.266: [TUN] [test] peer(bBF4…6PH4) - Routine: sequential receiver - started 2020-03-13 19:01:40.267: [TUN] [test] peer(bBF4…6PH4) - Routine: nonce worker - started 2020-03-13 19:01:40.267: [TUN] [test] peer(bBF4…6PH4) - Routine: sequential sender - started 2020-03-13 19:01:40.267: [TUN] [test] Monitoring default v4 routes 2020-03-13 19:01:40.269: [TUN] [test] Binding v4 socket to interface 14 (blackhole=false) 2020-03-13 19:01:40.270: [TUN] [test] Setting device v4 addresses 2020-03-13 19:01:40.355: [TUN] [test] peer(bBF4…6PH4) - Sending handshake initiation 2020-03-13 19:01:40.385: [TUN] [test] peer(bBF4…6PH4) - Awaiting keypair 2020-03-13 19:01:40.503: [TUN] [test] peer(bBF4…6PH4) - Received handshake response 2020-03-13 19:01:40.510: [TUN] [test] peer(bBF4…6PH4) - Obtained awaited keypair 2020-03-13 19:01:40.827: [TUN] [test] Listening for UAPI requests 2020-03-13 19:01:40.827: [TUN] [test] Startup complete 2020-03-13 19:01:40.827: [TUN] [test] Monitoring default v6 routes 2020-03-13 19:01:40.828: [TUN] [test] Binding v6 socket to interface 14 (blackhole=false) 2020-03-13 19:01:40.829: [TUN] [test] Setting device v6 addresses 2020-03-13 19:02:09.417: [TUN] [test] peer(bBF4…6PH4) - Received handshake initiation 2020-03-13 19:02:09.418: [TUN] [test] peer(bBF4…6PH4) - Sending handshake response 2020-03-13 19:02:14.538: [TUN] [test] peer(bBF4…6PH4) - Received handshake initiation 2020-03-13 19:02:14.538: [TUN] [test] peer(bBF4…6PH4) - Sending handshake response 2020-03-13 19:02:25.034: [TUN] [test] peer(bBF4…6PH4) - Received handshake initiation 2020-03-13 19:02:25.034: [TUN] [test] peer(bBF4…6PH4) - Sending handshake response 一直重复Received handshake initiation-Sending handshake response 同时在任务管理器显示Tunnel有大约160Mbps的发送(实际无数据传输)。 请问这是什么情况呢?
    Qabalah8个月前 (2020-03-13)回复
  12. 好久没来过了,今天过来发现更新了
    shaw8个月前 (2020-03-13)回复
  13. 泰迪高产似母猪
    pl8个月前 (2020-03-10)回复
  14. 安装完成了,客户端连接一直卡在handshake是怎么回事?
    武英仲8个月前 (2020-02-24)回复
  15. 内核那一步太难了,Ubuntu16很难安装的上.....
    saya8个月前 (2020-02-24)回复